<template>
  <div>
    <v-card flat class="pa-10">
      <v-row justify="center">
        <v-col :cols="12" :sm="12" :md="7" :lg="7" :xl="7">
          <v-card class="mx-auto">
            <v-toolbar color="grey" dark>
              <v-spacer></v-spacer>
              <v-text-field
                v-model="searchPermisosDisponibles"
                label="Buscar vistas..."
                flat
                dark
                solo-inverted
                append-icon="mdi-magnify"
                hide-details
                clear-icon="mdi-close-circle-outline"
              ></v-text-field>
            </v-toolbar>
            <v-subheader>VISTAS DEL PERFIL</v-subheader>
            <v-divider />
            <v-card-text
              style="min-height:400px; max-height:400px; overflow: auto;"
            >
              <vistas-perfil
                :search="searchPermisosDisponibles"
                v-if="src.length > 0"
                :values="values"
                :items="src"
                v-model="selectedVistas"
              />
            </v-card-text>
          </v-card>
        </v-col>
      </v-row>
    </v-card>
  </div>
</template>
<script>
import store from "@/store";
import VistasPerfil from "@/views/secure/accesos/perfiles/components/VistasPerfil.vue";
const axios = store.state.axiosApiLocal;
const serviceCommons = store.state.serviceCommons;
let counter = 0;
export default {
  name: "Component-Vistas",
  components: {
    VistasPerfil,
  },
  props: ["perfilIn"],
  data() {
    return {
      loading: false,
      searchPermisosDisponibles: null,
      perfil: this.perfilIn,
      selectedVistas: [],
      values: [],
      vistas: [],
      src: [],
      items: [],
    };
  },
  watch: {
    selectedVistas(val, pre) {
      counter++;
      if (val) {
        this.vistas = [];
        let listParents = [];
        val.forEach((element) => {
          let item = JSON.parse(JSON.stringify(this.items));
          let parents = this.ancestors(item, element);
          if (!this.vistas.includes(element)) {
            this.vistas.push(element);
          }
          listParents = listParents.concat(parents);
        });
        this.vistas = listParents.concat(this.vistas);
        this.vistas = Array.unique(this.vistas);
        val = JSON.parse(JSON.stringify(this.vistas));
        if (counter > 3) {
          this.postVistasPerfil();
        }
      }
    },
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
  },
  methods: {
    ancestors(root, idFind) {
      var ancestors = [];
      const pathToTemp = (localArray, localTarget) => {
        var result;
        localArray.some(({ idVista, children = [] }) => {
          if (idVista === localTarget) {
            result = idVista;
            return result;
          }
          var temp = pathToTemp(children, localTarget);
          if (temp) {
            ancestors.push(idVista);
            result = idVista + "." + temp;
            return result;
          }
        });
        return result;
      };
      pathToTemp(root, idFind);
      return ancestors;
    },
    unflatten(src) {
      src = JSON.parse(JSON.stringify(src));
      return JSON.unflatten(src, "idVista", "idVistaPadre");
    },
    postVistasPerfil() {
      let body = {
        vistas: this.vistas.map((vista) => {
          return { idVista: vista };
        }),
      };
      axios
        .post(
          "/accesos/sistema/perfiles/v1/" + this.perfil.idPerfil + "/vistas",
          body
        )
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    getArbolVistas() {
      this.loading = true;
      axios("/accesos/sistema/vistas/v1/")
        .then((response) => {
          if (response.data) {
            let data = response.data.resultado.vistas;
            this.src = data;
            this.items = this.unflatten(this.src);
            this.getVistasPerfil();
          }
        })
        .catch((error) => {
          console.log(error);
          this.items = [];
        })
        .finally(() => {
          this.loading = false;
        });
    },
    getVistasPerfil() {
      this.loading = true;
      axios("/accesos/sistema/vistas/v1/perfiles/" + this.perfil.idPerfil)
        .then((response) => {
          let data = response.data;
          if (data) {
            this.selectedVistas = [];
            data.resultado.vistas.forEach((vista) => {
              this.selectedVistas.push(vista.idVista);
              this.values.push(vista);
            });
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            this.selectedVistas = [];
          } else {
            console.log(error);
          }
        })
        .finally(() => {
          this.loading = false;
        });
    },
  },
  created() {
    this.getArbolVistas();
  },
};
</script>
